
#include "Graph.h"
#include "common.h"
#include <memory.h>		//	memsetԼ   ߰

/*	׷ ʱȭϴ Լ Ű  .	*/
void GraphInit(Graph* pGraph, int VertextCount)
{
	int i;

	pGraph->NumOfEdge = 0;
	pGraph->NumOfVertex = VertextCount;

	pGraph->pVertexList = (Vertex**)malloc(sizeof(Vertex) * pGraph->NumOfVertex);

	for ( i = 0; i < pGraph->NumOfVertex; i++)
		pGraph->pVertexList[i] = NULL;

	/*	ʱȭ	*/
	pGraph->pVisit = (int*)malloc(sizeof(int) * VertextCount);
	memset(pGraph->pVisit, NOT_VISITED, sizeof(int) * VertextCount);

	pGraph->count = 0;	//	 ʱȭ
}

/*	׷  Orign  Dest ߰ϴ Լ	*/
void AddVertex(Graph* pGraph, int Orign, int Dest, int Cost)
{
	/*	߰  Dest .	*/
	Vertex* newVertex = (Vertex*)malloc(sizeof(Vertex));
	newVertex->Dest = Dest;
	newVertex->pNext = NULL;
	newVertex->Cost = Cost;		//	 ߰

	Vertex* pCurVertex = NULL;

	/*	 Orign  Dest ߰ϴ κ	*/
	if (pGraph->pVertexList[Orign] == NULL)
		pGraph->pVertexList[Orign] = newVertex;
	else
	{
		pCurVertex = pGraph->pVertexList[Orign];

		while (pCurVertex->pNext != NULL)	
			pCurVertex = pCurVertex->pNext;

		pCurVertex->pNext = newVertex;
	}
}

/*	׷  ߰ϴ Լ,  Orign  Dest Ѵ.	*/
void AddEdge(Graph* pGraph, int Orign, int Dest, int Cost)
{
	pGraph->NumOfEdge++;

	/*	 Orign Dest 	*/
	AddVertex(pGraph, Orign, Dest, Cost);

	/*	 Dest Orign 	*/
	AddVertex(pGraph, Dest, Orign, Cost);
}

/*	׷   Ѵ Լ	*/
void DisplayEdgeInfo(Graph* pGraph)
{
	int i;
	Vertex* pCurVertex = NULL;

	printf("   =>\t%d\n\n", pGraph->NumOfEdge);

	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		if (pGraph->pVertexList[i] == NULL)
			continue;

		printf("%c  =>\t", 'A' + i);

		pCurVertex = pGraph->pVertexList[i];

		while (pCurVertex != NULL)
		{
			printf("%c %d\t", 'A' + pCurVertex->Dest, pCurVertex->Cost);
			pCurVertex = pCurVertex->pNext;
		}
		printf("\n");
	}
}

/*	     ϴ Լ	*/
void RemoveAllVertex(Vertex* pHead)
{
	Vertex* pCurVertex = NULL;
	Vertex* pDelVertex = NULL;

	if (pHead == NULL)
		return;

	pCurVertex = pHead;

	while (pCurVertex != NULL)
	{
		pDelVertex = pCurVertex;
		pCurVertex = pCurVertex->pNext;
		
		free(pDelVertex);
	}
}

/*	׷   ϴ Լ	*/
void DestroyGraph(Graph* pGraph)
{
	int i;

	if (pGraph == NULL)	
		return;
	
	/*	
		pGraph NULL ƴϸ,  Ͱ ִٴ ǹ̸, 
		pGraphȿ ִ pVertexList͸  Ѵ	
	*/
	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		/*	NULL̸, ʿǷ,  ̵Ѵ.	*/
		if (pGraph->pVertexList[i] == NULL)
			continue;	

		/*	     	*/
		RemoveAllVertex(pGraph->pVertexList[i]);

		pGraph->pVertexList[i] = NULL;
	}

	/*	    ʱȭ	*/
	pGraph->NumOfEdge = pGraph->NumOfVertex = 0;

	/*	Ҵ 		*/
	if (pGraph->pVisit != NULL)
		free(pGraph->pVisit);

	pGraph->pVisit = NULL;
}

/*	StartVertex    켱 Ž ϴ Լ	*/
void SearchDFSByRecur(Graph* pGraph, int StartVertex)
{
	Vertex* pCurVertex = NULL;

	/*	 StartVertex 湮 		*/
	//	pGraph->pVisit[StartVertex] = VISITED;
	
	pGraph->pVisit[StartVertex] = pGraph->count;

	//	printf("%c ", StartVertex + 65);	//	湮  

	/*	 StartVertex   ߿ 湮    Ž 	*/
	for (pCurVertex = pGraph->pVertexList[StartVertex];  pCurVertex != NULL; pCurVertex = pCurVertex->pNext)
	{
		if (pGraph->pVisit[pCurVertex->Dest] == NOT_VISITED)
			SearchDFSByRecur(pGraph, pCurVertex->Dest);
	}
}

/*	  ã Լ	*/
void FindConnectedComponent(Graph* pGraph)
{
	int i;

	pGraph->count = 0;

	/*	  ã ؼ,    켱 Ž Ѵ.	*/
	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		/*	湮    	*/
		if (pGraph->pVisit[i] == NOT_VISITED)
		{ 
			pGraph->count += 1;

			/*	ش    켱 Ž		*/
			SearchDFSByRecur(pGraph, i);
		}
	}

	/*	Display	*/
	for (i = 0; i < pGraph->NumOfVertex; i++)
	{
		printf("%c   : %d\n", i + 65, pGraph->pVisit[i]);
	}
}

